// Title : C_Sample for Lock & Key 32
// File  : Mainwnd.cpp
// By    : J.R.Mainwaring
//
// Copyright(C) 1998 J.R.Mainwaring

#include <afxwin.h>
#include "mainwnd.h"
#include "resource.h"
#include "lnk32.h"

CMainWnd::CMainWnd()
{
    m_bLoggedIn = FALSE;
    m_wKeyFlags = 0;
        
    Create(NULL,"Lock & Key(TM) - C_Sample",WS_OVERLAPPEDWINDOW,rectDefault,NULL,"C_SAMPLE_MENU");
}

void CMainWnd::OnExit()
{
    DestroyWindow();
}

void CMainWnd::OnBackup()
{
	BOOL bOK = LnkLogin(GetSafeHwnd(),"BACKUP",NULL);

	MessageBox(bOK ? "Access to Backup granted." : "Access to Backup denied.", "C_Sample");
}

void CMainWnd::OnRestore()
{
	BOOL bOK = LnkLogin(GetSafeHwnd(),"RESTORE",NULL);

	MessageBox(bOK ? "Access to Restore granted." : "Access to Restore denied.", "C_Sample");
}

void CMainWnd::OnLogin()
{
    BOOL bGotAllKeys;
    
    m_bLoggedIn = LnkLogin(GetSafeHwnd(),NULL,m_szUid);

    if (m_bLoggedIn)
        bGotAllKeys = LnkTestKeys(
            m_szUid,
            "Create Database,Open Database,Close Database,Add Record,Edit Record,Delete Record",
            &m_wKeyFlags);
    else
        m_wKeyFlags = 0;
}

void CMainWnd::OnLogout()
{
    m_bLoggedIn = FALSE;
    m_wKeyFlags = 0;
}

void CMainWnd::OnUserMaint()
{
    BOOL bOK = LnkUserMaint(GetSafeHwnd(),NULL);
}

void CMainWnd::OnChgPwd()
{
    BOOL bOK = LnkChgPwd(GetSafeHwnd(),NULL);
}

void CMainWnd::OnUpdateCreateDatabase(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(m_wKeyFlags & 1);
}

void CMainWnd::OnUpdateOpenDatabase(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(m_wKeyFlags & 2);
}

void CMainWnd::OnUpdateCloseDatabase(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(m_wKeyFlags & 4);
}

void CMainWnd::OnUpdateAddRecord(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(m_wKeyFlags & 8);
}

void CMainWnd::OnUpdateEditRecord(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(m_wKeyFlags & 16);
}

void CMainWnd::OnUpdateDeleteRecord(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(m_wKeyFlags & 32);
}

void CMainWnd::OnUpdateLogin(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(!m_bLoggedIn);
}

void CMainWnd::OnUpdateLogout(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(m_bLoggedIn);
}

BEGIN_MESSAGE_MAP(CMainWnd,CFrameWnd)
    ON_COMMAND(IDM_EXIT,OnExit)
    ON_COMMAND(IDM_LOGIN,OnLogin)
	ON_COMMAND(IDM_BACKUP,OnBackup)
	ON_COMMAND(IDM_RESTORE,OnRestore)
    ON_COMMAND(IDM_LOGOUT,OnLogout)
    ON_COMMAND(IDM_USERMAINT,OnUserMaint)
    ON_COMMAND(IDM_CHGPWD,OnChgPwd)
    ON_UPDATE_COMMAND_UI(IDM_CREATEDB,OnUpdateCreateDatabase)
    ON_UPDATE_COMMAND_UI(IDM_OPENDB,OnUpdateOpenDatabase)
    ON_UPDATE_COMMAND_UI(IDM_CLOSEDB,OnUpdateCloseDatabase)
    ON_UPDATE_COMMAND_UI(IDM_ADDRECORD,OnUpdateAddRecord)
    ON_UPDATE_COMMAND_UI(IDM_EDITRECORD,OnUpdateEditRecord)
    ON_UPDATE_COMMAND_UI(IDM_DELRECORD,OnUpdateDeleteRecord)
    ON_UPDATE_COMMAND_UI(IDM_LOGIN,OnUpdateLogin)
    ON_UPDATE_COMMAND_UI(IDM_LOGOUT,OnUpdateLogout)
END_MESSAGE_MAP()
