VERSION 5.00
Begin VB.Form frmVB_Sample 
   Caption         =   "Lock & Key(TM) - VB_Sample"
   ClientHeight    =   5370
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7155
   LinkTopic       =   "Form1"
   ScaleHeight     =   5370
   ScaleWidth      =   7155
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox ClientArea 
      Enabled         =   0   'False
      Height          =   1455
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1935
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuOperations 
      Caption         =   "&Operations"
      Begin VB.Menu mnuCreateDatabase 
         Caption         =   "&Create Database"
      End
      Begin VB.Menu mnuOpenDatabase 
         Caption         =   "&Open Database"
      End
      Begin VB.Menu mnuCloseDatabase 
         Caption         =   "&Close Database"
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAddRecord 
         Caption         =   "&Add Record"
      End
      Begin VB.Menu mnuEditRecord 
         Caption         =   "&Edit Record"
      End
      Begin VB.Menu mnuDeleteRecord 
         Caption         =   "&Delete Record"
      End
   End
   Begin VB.Menu mnuUtils 
      Caption         =   "&Utils"
      Begin VB.Menu mnuBackup 
         Caption         =   "&Backup"
      End
      Begin VB.Menu mnuRestore 
         Caption         =   "&Restore"
      End
   End
   Begin VB.Menu mnuSecurity 
      Caption         =   "&Security"
      Begin VB.Menu mnuLogin 
         Caption         =   "&Login..."
      End
      Begin VB.Menu mnuLogout 
         Caption         =   "L&ogout"
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuUserMaintenance 
         Caption         =   "&User Maintenance..."
      End
      Begin VB.Menu mnuChangePassword 
         Caption         =   "&Change Password..."
      End
   End
End
Attribute VB_Name = "frmVB_Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Title : VB_Sample for Lock & Key 32
' File  : VB_Sample.frm
' By    : J.R.Mainwaring
'
' Copyright(C) 1998 J.R.Mainwaring

' Global data
Private UserId As String
Private bCreateDatabase As Boolean
Private bOpenDatabase As Boolean
Private bCloseDatabase As Boolean
Private bAddRecord As Boolean
Private bEditRecord As Boolean
Private bDeleteRecord As Boolean

' Lock & Key(TM) DLL functions
Private Declare Function LnkLogin Lib "Lnk32.dll" (ByVal hwnd As Long, ByVal lpszKeyList As String, ByVal lpszUid As String) As Long
Private Declare Function LnkTestKeys Lib "Lnk32.dll" (ByVal lpszUid As String, ByVal lpszKeyList As String, ByRef lpKeyFlags As Integer) As Long
Private Declare Function LnkUserMaint Lib "Lnk32.dll" (ByVal hwnd As Long, ByVal lpszUid As String) As Long
Private Declare Function LnkChgPwd Lib "Lnk32.dll" (ByVal hwnd As Long, ByVal lpszUid As String) As Long

Private Sub UpdateForm()
    ' If nobody logged in
    If UserId = "" Then
        ' No access to protected menu options
        bCreateDatabase = False
        bOpenDatabase = False
        bCloseDatabase = False
        bAddRecord = False
        bEditRecord = False
        bDeleteRecord = False
        ' Allowed to login but not logout
        mnuLogin.Enabled = True
        mnuLogout.Enabled = False
    Else
        ' Allowed to logout but not login
        mnuLogout.Enabled = True
        mnuLogin.Enabled = False
    End If
    ' Update menu options
    mnuCreateDatabase.Enabled = bCreateDatabase
    mnuOpenDatabase.Enabled = bOpenDatabase
    mnuCloseDatabase.Enabled = bCloseDatabase
    mnuAddRecord.Enabled = bAddRecord
    mnuEditRecord.Enabled = bEditRecord
    mnuDeleteRecord.Enabled = bDeleteRecord
End Sub
Private Sub Form_Load()
    ' Position client area
    ClientArea.Left = 0
    ClientArea.Top = 0
    
    ' No user logged in
    UserId = ""
    UpdateForm
End Sub

Private Sub Form_Resize()
    ' Resize client area
    ClientArea.Width = Me.ScaleWidth
    ClientArea.Height = Me.ScaleHeight
End Sub

Private Sub mnuBackup_Click()
    ' Allow login to backup utility
    If LnkLogin(Me.hwnd, "Backup", vbNullString) Then
        MsgBox "Access to Backup granted.", 0, "VB_Sample"
    Else
        MsgBox "Access to Backup denied.", 0, "VB_Sample"
    End If
End Sub

Private Sub mnuChangePassword_Click()
    Dim OK As Long
    
    ' Allow user to change their password
    OK = LnkChgPwd(Me.hwnd, vbNullString)
End Sub

Private Sub mnuExit_Click()
    End
End Sub

Private Sub mnuLogin_Click()
    Dim GotAllKeys As Long
    Dim KeyFlags As Integer
    
    ' Make room for returned user id
    UserId = Space$(11)
    ' Login
    If LnkLogin(Me.hwnd, vbNullString, UserId) Then
        ' Login OK, so check keys
        GotAllKeys = LnkTestKeys(UserId, "Create Database,Open Database,Close Database,Add Record,Edit Record,Delete Record", KeyFlags)
        bCreateDatabase = (KeyFlags And 1)
        bOpenDatabase = (KeyFlags And 2)
        bCloseDatabase = (KeyFlags And 4)
        bAddRecord = (KeyFlags And 8)
        bEditRecord = (KeyFlags And 16)
        bDeleteRecord = (KeyFlags And 32)
    Else
        ' Login failed, so nobody logged in
        UserId = ""
    End If
    ' Update form state
    UpdateForm
End Sub

Private Sub mnuLogout_Click()
    ' Logout
    UserId = ""
    UpdateForm
End Sub

Private Sub mnuRestore_Click()
    ' Allow login to restore utility
    If LnkLogin(Me.hwnd, "Restore", vbNullString) Then
        MsgBox "Access to Restore granted.", 0, "VB_Sample"
    Else
        MsgBox "Access to Restore denied.", 0, "VB_Sample"
    End If
End Sub

Private Sub mnuUserMaintenance_Click()
    Dim OK As Long
    
    ' Allow access to User Maintenance dialog
    OK = LnkUserMaint(Me.hwnd, vbNullString)
End Sub
